unit UserStatsSysop;

{ This is the Type I external, that is found in the System Prefs... dialog.  It is used to set the }
{ preferences in &UserStats.  Special thanks to Walter Korman for his great examples.         }

{ You can use this code however you want, but I retain some kind of rights, don't I?               }

{ Compiled code is 1991 Taziar Medakan and TMM Software                                               }

interface

	uses
		HermHeaders;

	type

		SettingsHdl = ^SettingsPtr;  { This is the record type used, along with eInfoRec, to set }
		SettingsPtr = ^Settings;       { various things for use with &UserStats.                        }
		Settings = record
				mainKey: char;
			end;

	procedure MAIN (message, item: integer; var theEvent: EventRecord; myHerm: HermDataPtr; var XHRMrefcon: longint; ConfigDialog: DialogPtr);

implementation

	const
		MMKet = 4;
		useSLet = 6;
		restrictionet = 8;

	procedure GetText (id: integer; the_dialog: DialogPtr; var into: str255); { Find out what is in an }
		var 																					   { edit text box             }
			hdl: handle;
			theType: integer;
			theRect: rect;
			t: str255;
	begin
		GetDItem(the_dialog, id, theType, hdl, theRect);
		GetIText(hdl, t);
		into := t;
	end;

	procedure SetText (id: integer; the_dialog: DialogPtr; theText: string); { Set what is in an }
		var																			            { edit text box       }
			hdl: handle;
			theType: integer;
			theRect: rect;
	begin
		GetDItem(the_dialog, id, theType, hdl, theRect);
		SetIText(hdl, theText);
	end;

	function cstr (i: integer): string;
		var
			t: str255;
	begin
		NumToString(i, t);
		cstr := t;
	end;

	function s2n (the_string: str255): integer;
		var
			temp: longint;
	begin
		StringToNum(the_string, temp);
		s2n := temp;
	end;

	procedure SetStuff (theDialog: dialogPtr); { Read in the resources and set up the dialog }
		var
			theResource: eInfoRec;
			optionResource: Settings;
			temp: str255;

		procedure readTheResource (var theResource: eInfoRec);
			var
				myExInfoHand: eInfoHand;
		begin
			myExInfoHand := eInfoHand(GetResource('HRMS', 100));
			theResource := myExInfoHand^^;
			ReleaseResource(handle(myExInfoHand))
		end;

		procedure readOptionResource (var theResource: Settings);
			var
				myHand: handle;
				optionHand: SettingsHdl;
		begin
			optionHand := SettingsHdl(GetResource('STAT', 100));
			theResource := optionHand^^;
			ReleaseResource(handle(optionHand))
		end;

	begin
		readTheResource(theResource);
		readOptionResource(optionResource);
		SetText(restrictionet, theDialog, theResource.restriction);
		SetText(MMKet, theDialog, optionResource.mainKey);
		SetText(useSLet, theDialog, cstr(theResource.minSLForMenu));
		SelIText(theDialog, MMKet, 0, 255);
	end;

	procedure GetStuff (theDialog: DialogPtr); { Save changes }
		var
			theResource: eInfoRec;
			optionResource: Settings;
			temp: str255;

		procedure writeTheResource (var theResource: eInfoRec);
			var
				myExInfoHand: eInfoHand;
		begin
			myExInfoHand := eInfoHand(GetResource('HRMS', 100));
			HNoPurge(handle(myExInfoHand));
			myExInfoHand^^ := theResource;
			ChangedResource(handle(myExInfoHand));
			WriteResource(handle(myExInfoHand));
			HPurge(handle(myExInfoHand));
			ReleaseResource(handle(myExInfoHand))
		end;

		procedure writeOptionResource (var optionResource: Settings);
			var
				optionHand: SettingsHdl;
		begin
			optionHand := SettingsHdl(GetResource('STAT', 100));
			HNoPurge(handle(optionHand));
			optionHand^^ := optionResource;
			ChangedResource(handle(optionHand));
			WriteResource(handle(optionHand));
			HPurge(handle(optionHand));
			ReleaseResource(handle(optionHand))
		end;

	begin
		GetText(restrictionet, theDialog, temp);
		if (length(temp) > 0) and (temp[1] <> ' ') then
			theResource.restriction := temp[1]
		else
			theResource.restriction := char(0);
		GetText(MMKet, theDialog, temp);
		optionResource.mainKey := temp;
		GetText(useSLet, theDialog, temp);
		theResource.minSLForMenu := s2n(temp);
		writeTheResource(theResource);
		writeOptionResource(optionResource)
	end;

	procedure MAIN (message, item: integer; var theEvent: EventRecord; myHerm: HermDataPtr; var XHRMrefcon: longint; ConfigDialog: DialogPtr);
	begin
		case message of
			initDev:
				SetStuff(ConfigDialog);
			CloseDev:
				GetStuff(ConfigDialog);
			otherwise
		end
	end;

end.