
unit UserStatsExt;

{ This is the Type II external that does all the dirtywork.  In future versions, the option of running }
{ &UserStats on logon will be implemented.  Until then...                                                                }
{ Thanks to Sam Kass and Walter Korman for their great source examples                                      }
{ Feel free to use and distribute this code.																	   }
{ Remember that the compiled code is 1991 Taziar Medakan and TMM Software                          }
{ Support for &UserStats is available on Olympus BBS, (213)275-6975, or Excalibur BBS,           }
{ (415)349-7322.  Thanks for listening.																	   }

interface

	uses
		HermHeaders;

	procedure MAIN (HermSetup: UserXIPtr);

implementation

	const
		fromMain = 2;
		fromExt = 3;
		CPUResID = 15;
		pauseString = '[PAUSE]';

	procedure readTheResource (var theResource: eInfoRec); { Read in the minSL, etc}
		var
			myExInfoHand: eInfoHand;
	begin
		myExInfoHand := eInfoHand(GetResource('HRMS', 100));
		theResource := myExInfoHand^^;
		ReleaseResource(handle(myExInfoHand))
	end;

	procedure readOptionResource (var optionResource: Settings); { Read in my own variables }
		var
			optionHand: SettingsHdl;
	begin
		optionHand := SettingsHdl(GetResource('STAT', 100));
		optionResource := optionHand^^;
		ReleaseResource(handle(optionHand))
	end;

	procedure MAIN (HermSetup: UserXIPtr);

		var
			i: integer;
			s1, temp: str255;

	begin
		with HermSetup^ do
			begin
				if message <> closeExternal then
					begin
						if privates = nil then  {never been called before}
							begin
								privates := myPrivsHand(NewHandle(SizeOf(myPrivs)));
								MoveHHi(handle(privates));
								HNoPurge(handle(privates));
								for i := 1 to totalNodes do
									begin
										privates^^.activeOn[i] := false;
										privates^^.stage[i] := 0;
									end;
							end;
						readTheResource(privates^^.sett.hermSettings);
						readOptionResource(privates^^.sett.mySettings);
						if (message = ActiveExt) and (not privates^^.activeOn[curNode^]) then
							begin
								privates^^.activeOn[curNode^] := true;
								privates^^.stage[curNode^] := 5;
								privates^^.comingFrom := fromExt;
							end;
					end;

				case message of

					closeExternal:

						begin
							if privates <> nil then
								begin
									HPurge(handle(privates));
									DisposHandle(handle(privates));
									privates := nil;
								end;
						end;

					closeNode:

						begin
							privates^^.activeOn[curNode^] := false;
							privates^^.stage[curNode^] := 0;
						end;

					idle:

						begin
							for i := 1 to totalNodes do
								begin
									if (n[i]^.curPrompt = privates^^.sett.mySettings.mainKey) and (n[i]^.boardsection = MainMenu) and (n[i]^.thisUser.secLevel >= privates^^.sett.hermSettings.minSLForMenu) then
										begin { If they are at the Main Menu and select &UserStats }
											n[i]^.ActiveUserExternal := extID;
											privates^^.comingFrom := fromMain;
											privates^^.activeOn[i] := true;
											privates^^.stage[i] := 5;
											n[i]^.boardsection := EXTERNAL;
										end;
								end;
						end;

					activeExt:

						begin
							case privates^^.stage[curNode^] of

								5:  { Determine where they are coming from... }

									begin
										if (privates^^.comingFrom = fromMain) then
											begin
												if (n[curNode^]^.thisUser.canANSI) then
													privates^^.stage[curNode^] := 10
												else
													begin
														privates^^.stage[curNode^] := 7;
													end;
											end;
										if (privates^^.comingFrom = fromExt) then
											begin
												if (n[curNode^]^.thisUser.canANSI) then
													privates^^.stage[curNode^] := 10
												else
													privates^^.stage[curNode^] := 7;
											end;
									end;

								7: { No ANSI?  How sad... }
									begin
										bCR(procs[0]);
										OutLine('Sorry, &UserStats requires ANSI support.', false, 4, procs[1]);
										bCR(procs[0]);
										bCR(procs[0]);
										PausePrompt(pauseString, procs[14]);
										n[curNode^]^.savedBDAction := none;
										privates^^.stage[curNode^] := 15;
									end;

								10:  { Draw in the main ANSI screen }

									begin

{ This is all of the ANSI code that draws the ANSI boxes in green }
{ Thanks to Wras and ANSI Mouse for this!!                                 }

										ANSICode('0;22;24;37;40m', procs[13]);
										ANSICode('H', procs[13]);
										ANSICode('2J', procs[13]);
										ANSICode('34;40mͻ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                                        ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                     ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                                        ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('0;22;30;40m                     ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                                        ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                     ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                                        ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                     ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                                        ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                     ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                                        ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                     ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                             ', procs[13]);
										ANSICode('34;40m͹', procs[13]);
										ANSICode('30;40m                     ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m͹', procs[13]);
										ANSICode('30;40m                          ', procs[13]);
										ANSICode('34;40m͹', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                             ', procs[13]);
										ANSICode('34;40mͼ', procs[13]);
										ANSICode('30;40m                     ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                              ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                               ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                              ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                               ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                              ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                               ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                              ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                               ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                              ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                               ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('34;40m͹', procs[13]);
										ANSICode('30;40m                               ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                               ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                               ', procs[13]);
										ANSICode('34;40m', procs[13]);
										ANSICode('30;40m                                               ', procs[13]);
										ANSICode('34;40mͼ', procs[13]);

{ This is the end of the boxes code }


{ This is all of the ANSI code that draws the ANSI text in various colors }
{ Thanks to Wras and ANSI Mouse for this!!                                            }

										ANSICode('30;40m                                            ', procs[13]);
										ANSICode('0m ', procs[13]);
										ANSICode('0;22;24;30;40m', procs[13]);
										ANSICode('1;34;40m', procs[13]);
										ANSICode('2;4HYour User Information', procs[13]);
										ANSICode('2;60HToday So Far...', procs[13]);
										ANSICode('10;3HYour Message Information', procs[13]);
										ANSICode('10;60HMiscellaneous', procs[13]);
										ANSICode('0;22;30;40m', procs[13]);
										ANSICode('1;36;40m', procs[13]);
										ANSICode('3;4H', procs[13]);
										ANSICode('3;60H', procs[13]);
										ANSICode('11;3H', procs[13]);
										ANSICode('11;50H', procs[13]);
										ANSICode('0;31;40m', procs[13]);
										ANSICode('4;4HHandle :', procs[13]);
										ANSICode('5;4HName   :', procs[13]);
										ANSICode('6;4HSL     :', procs[13]);
										ANSICode('7;4HDSL    :', procs[13]);
										ANSICode('8;4HCPU    :', procs[13]);
										ANSICode('4;31HAge      :', procs[13]);
										ANSICode('5;31HPhone    :', procs[13]);
										ANSICode('6;31HUploads  :', procs[13]);
										ANSICode('7;31HDownloads:', procs[13]);
										ANSICode('4;60HPosts     :', procs[13]);
										ANSICode('5;60HE-Mail    :', procs[13]);
										ANSICode('6;60HUploads   :', procs[13]);
										ANSICode('7;60HMin Active:', procs[13]);
										ANSICode('8;60HCalls     :', procs[13]);
										ANSICode('1;34;40m', procs[13]);
										ANSICode('12;7HToday', procs[13]);
										ANSICode('12;25HTotal', procs[13]);
										ANSICode('1;36;40m', procs[13]);
										ANSICode('13;7H', procs[13]);
										ANSICode('13;25H', procs[13]);
										ANSICode('0;22;30;47m', procs[13]);
										ANSICode('0;31;40m', procs[13]);
										ANSICode('14;3HMessages Posted :', procs[13]);
										ANSICode('15;3HE-Mail Sent     :', procs[13]);
										ANSICode('14;25HMessages Posted :', procs[13]);
										ANSICode('15;25HE-Mail Sent     :', procs[13]);
										ANSICode('12;50HTimes On       :', procs[13]);
										ANSICode('13;50HIllegal Logons :', procs[13]);
										ANSICode('14;50HTimes on Today :', procs[13]);
										ANSICode('15;50HTotal Time On  :', procs[13]);
										ANSICode('16;50HBaud Rate      :', procs[13]);
										ANSICode('17;50HLast Call Date :', procs[13]);
										ANSICode('1;37;44m', procs[13]);
										ANSICode('9;36H&UserStats by Taz', procs[13]);
										ANSICode('0m', procs[13]);
										ANSICode('18;1H ', procs[13]);
										ANSICode('0;37;40m', procs[13]);

{ This is the end of the ANSI text code }

{ Now comes the part where we draw in the info specific to the user }

										ANSICode('0;22;24;37;40m', procs[13]);
										ANSICode('37;40m', procs[13]);
										ANSICode(Concat('4;13H', n[curNode^]^.thisUser.UserName), procs[13]);
										ANSICode(Concat('5;13H', n[curNode^]^.thisUser.RealName), procs[13]);
										NumToString(n[curNode^]^.thisUser.SecLevel, s1);
										ANSICode(Concat('6;13H', s1), procs[13]);
										NumToString(n[curNode^]^.thisUser.TransferLevel, s1);
										ANSICode(Concat('7;13H', s1), procs[13]);
										GetIndString(temp, CPUResID, (n[curNode^]^.thisUser.ComputerType));
										s1 := temp;
										ANSICode(Concat('8;13H', s1), procs[13]);
										NumToString(n[curNode^]^.thisUser.age, s1);
										ANSICode(Concat('4;42H', s1), procs[13]);
										ANSICode(Concat('5;42H', n[curNode^]^.thisUser.Phone), procs[13]);
										NumToString(n[curNode^]^.thisUser.UploadedK, s1);
										ANSICode(Concat('6;42H', s1, 'k'), procs[13]);
										NumToString(n[curNode^]^.thisUser.DownloadedK, s1);
										ANSICode(Concat('7;42H', s1, 'k'), procs[13]);
										NumToString(HermSetup^.HSystPtr^.mPostedToday, s1);
										ANSICode(Concat('4;72H', s1), procs[13]);
										NumToString(HermSetup^.HSystPtr^.eMailToday, s1);
										ANSICode(Concat('5;72H', s1), procs[13]);
										NumToString(HermSetup^.HSystPtr^.uploadsToday, s1);
										ANSICode(Concat('6;72H', s1), procs[13]);
										NumToString(HermSetup^.HSystPtr^.minsToday, s1);
										ANSICode(Concat('7;72H', s1), procs[13]);
										NumToString(HermSetup^.HSystPtr^.callsToday, s1);
										ANSICode(Concat('8;72H', s1), procs[13]);
										NumToString(n[curNode^]^.thisUser.MPostedToday, s1);
										ANSICode(Concat('14;21H', s1), procs[13]);
										NumToString(n[curNode^]^.thisUser.EMsentToday, s1);
										ANSICode(Concat('15;21H', s1), procs[13]);
										NumToString(n[curNode^]^.thisUser.MessagesPosted, s1);
										ANSICode(Concat('14;43H', s1), procs[13]);
										NumToString(n[curNode^]^.thisUser.EMailSent, s1);
										ANSICode(Concat('15;43H', s1), procs[13]);
										NumToString(n[curNode^]^.thisUser.TotalLogons, s1);
										ANSICode(Concat('12;67H', s1), procs[13]);
										NumToString(n[curNode^]^.thisUser.illegalLogons, s1);
										ANSICode(Concat('13;67H', s1), procs[13]);
										NumToString(n[curNode^]^.thisUser.MinOnToday, s1);
										ANSICode(Concat('14;67H', s1), procs[13]);
										NumToString(n[curNode^]^.thisUser.totalTimeOn, s1);
										ANSICode(Concat('15;67H', s1, ' mins'), procs[13]);
										NumToString(n[curNode^]^.currentBaud, s1);
										ANSICode(Concat('16;67H', s1, n[curNode^]^.curBaudNote), procs[13]);
										IUDateString((n[curNode^]^.thisUser.lastOn), shortDate, temp);
										s1 := temp;
										ANSICode(Concat('17;67H', s1), procs[13]);
										ANSICode('0m', procs[13]);
										ANSICode('18;1H ', procs[13]);
										ANSICode('0;37;40m', procs[13]);

{ This is the end of the unique user info }

										bCR(procs[0]);
										bCR(procs[0]);
										bCR(procs[0]);
										PausePrompt(pauseString, procs[14]);
										n[curNode^]^.savedBDAction := none;
										privates^^.stage[curNode^] := 15;

									end;

								15:  { Bye bye!! }
									begin
										n[curNode^]^.activeUserExternal := -1;
										begin
											privates^^.activeOn[curNode^] := false;
											privates^^.stage[curNode^] := 0;
											case privates^^.comingFrom of
												fromMain:
													GoHome(procs[7]);
												fromExt:
													;
												otherwise
											end;
										end;
									end;

								otherwise
							end;
						end;
					otherwise
				end;
			end;
	end;

end.