unit Leech_Sysop;

{This is the "Part I" external; the sysop interface external, which allows the sysop}
{to set various options within the Leech online game.}

interface
	uses
		HermHeaders;

	procedure MAIN (message, item: integer;
									var theEvent: EventRecord;
									myHerm: HermDataPtr;
									var XHRMrefcon: longint;
									ConfigDialog: DialogPtr);

implementation

	const
    {Note: all ID's are 1 greater than they are in the DITL, due to the UserItem #1 inserted by Hermes}
		rest_char_etext = 3;		{ID of Restriction Char edit text box}
		min_sl_etext = 4;			{ID of the Minimum SL edit text box}
		plays_allowed_etext = 6;	{ID of the Plays Allowed per Day edit text box}
		unlim_play_chk = 9;			{ID of the Unlimited Play by Sysop edit text box}

	procedure SetCheckBox (theDialog: dialogPtr;
									item: integer;
									up: boolean);
		var
			dType: integer;
			dItem: handle;
			tempRect: rect;
	begin
		GetDItem(theDialog, item, dType, dItem, tempRect);
		if up then
			SetCtlValue(controlHandle(dItem), 1)
		else
			SetCtlValue(controlHandle(dItem), 0)
	end;
	function GetCheckBox (theDialog: dialogPtr;
									item: integer): boolean;
		var
			dType: integer;
			dItem: handle;
			tempRect: rect;
	begin
		GetDItem(theDialog, item, dType, dItem, tempRect);
		if GetCtlValue(controlHandle(dItem)) = 1 then
			GetCheckBox := true
		else
			GetCheckBox := false
	end;


	procedure get_text (id: integer;
									the_dialog: DialogPtr;
									var into: str255);				{get the text from an edit text box}
		var
			hdl: handle;
			theType: integer;
			theRect: rect;
			t: str255;
	begin
		GetDItem(the_dialog, id, theType, hdl, theRect);
		GetIText(hdl, t);
		into := t
	end;

	procedure set_text (id: integer;
									the_dialog: DialogPtr;
									theText: string);					{set the text in an edit text box}
		var
			hdl: handle;
			theType: integer;
			theRect: rect;
	begin
		GetDItem(the_dialog, id, theType, hdl, theRect);
		SetIText(hdl, theText)
	end;

	function cstr (i: integer): string;				{convert integer to string}
		var
			t: str255;
	begin
		NumToString(i, t);
		cstr := t
	end;

	function s2n (the_string: str255): integer;		{convert string to integer}
		var
			temp: longint;
	begin
		StringToNum(the_string, temp);
		s2n := temp
	end;

	procedure SetStuff (theDialog: dialogPtr);
		var
			the_rec: eInfoRec;
			option_rec: leech_option_rec;
			temp: str255;

		procedure read_the_rec (var the_rec: eInfoRec);
			var
				e_hand: eInfoHand;
		begin
			e_hand := eInfoHand(GetResource('HRMS', 100));
			the_rec := e_hand^^;
			ReleaseResource(handle(e_hand))
		end;

		procedure read_option_rec (var the_rec: leech_option_rec);
			var
				option_hand: leechOptionHand;
		begin
			option_hand := leechOptionHand(GetResource('LCOP', 100));
			the_rec := option_hand^^;
			ReleaseResource(handle(option_hand))
		end;

	begin
		read_the_rec(the_rec);
		read_option_rec(option_rec);
		temp := the_rec.Restriction;
		set_text(rest_char_etext, theDialog, temp);
		set_text(min_sl_etext, theDialog, cstr(the_rec.minSLForMenu));
		set_text(plays_allowed_etext, theDialog, cstr(option_rec.plays_allowed));
		SetCheckBox(theDialog, unlim_play_chk, option_rec.unlim_sysop_play);
		SelIText(theDialog, rest_char_etext, 0, 255);
	end;

	procedure GetStuff (theDialog: DialogPtr);
		var
			the_rec: eInfoRec;
			option_rec: leech_option_rec;
			temp: str255;

		procedure write_the_rec (var the_rec: eInfoRec);
			var
				e_hand: eInfoHand;
		begin
			e_hand := eInfoHand(GetResource('HRMS', 100));		{get the old one}
			HNoPurge(handle(e_hand));
			e_hand^^ := the_rec;
			ChangedResource(handle(e_hand));
			WriteResource(handle(e_hand));
			HPurge(handle(e_hand));
			ReleaseResource(handle(e_hand))
		end;

		procedure write_option_rec (var the_rec: leech_option_rec);
			var
				option_hand: leechOptionHand;
		begin
			option_hand := leechOptionHand(GetResource('LCOP', 100));
			HNoPurge(handle(option_hand));
			option_hand^^ := the_rec;
			ChangedResource(handle(option_hand));
			WriteResource(handle(option_hand));
			HPurge(handle(option_hand));
			ReleaseResource(handle(option_hand))
		end;

	begin
		get_text(rest_char_etext, theDialog, temp);
		if length(temp) > 0 then
			the_rec.Restriction := temp[1]
		else
			the_rec.Restriction := char(0);
		get_text(min_sl_etext, theDialog, temp);
		the_rec.minSLForMenu := s2n(temp);
		get_text(plays_allowed_etext, theDialog, temp);
		option_rec.plays_allowed := s2n(temp);
		option_rec.unlim_sysop_play := GetCheckBox(theDialog, unlim_play_chk);
		write_the_rec(the_rec);
		write_option_rec(option_rec)
	end;

	procedure MAIN (message, item: integer;
									var theEvent: EventRecord;
									myHerm: HermDataPtr;
									var XHRMrefcon: longint;
									ConfigDialog: DialogPtr);
	begin
		case message of
			initDev: 
				SetStuff(ConfigDialog);
			hitDev: 
				if item = unlim_play_chk then
					SetCheckBox(ConfigDialog, unlim_play_chk, not GetCheckBox(ConfigDialog, unlim_play_chk));
			closeDev: 
				GetStuff(ConfigDialog);
			otherwise
		end
	end;

end.